require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

-- Attacks --
local function attack_attack(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end
  doMotion("X+Attack")
  param.attackCooldown = 27
end

-- the initialization function for this AI
function OnInit()
    local me, player = getMe(), getPlayer()

    param.attackCooldown = 0 

    param.prevTarget = nil

    param.seekDistX = 160 * 14 -- 7 from my center
    param.seekDistY = 160 * 18 -- 3 from my center

    param.attackDistX = 160 * 2
    param.seekDeadzoneDist = 160 * 1
end

-- the main update function for this AI
function OnUpdate()
  local me, player = getMe(), getPlayer()

  local target = getClosestPlayer(me.XPos, me.YPos)

  -- SCARY HACK WE SHOULD PROBABLY NOT DO --
  while shouldNeverUpdate() do end

  while true do
    target = player -- set the player as the target by default

    if tick_ok() then
      param.attackCooldown = math.max(0, param.attackCooldown - 1)
    end

    -- Update Target, Always? -- 
    if true
    then
      target = getClosestPartyMemberOnX()
    end

    if update_ok() then
      if isInRange(target, me.XPos, me.YPos, param.seekDistX, param.seekDistY)
      then
        if dist_sprite(target) <= param.attackDistX -- OK to check since we're in already in range
        and dist_sprite(target) > 0
        and param.attackCooldown <= 0
        then
          attack_attack()
        else
          if dist_sprite(target) < 0
          then
            turn_around(10)
          elseif math.abs(dist_sprite(target)) >= param.seekDeadzoneDist
          then
            approach_withTurn(target.XPos, 10)
          end
        end
      end

      -- Draw a point over our target --
      if aiDebug()
      then
        draw_point(target.XPos, 
          target.YPos + target.WorldCollisionHeight + 64
        )
      end
    end

    param.prevTarget = target
    wait() -- try to keep this at the end
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()
  return toReturn
end --OnBattleAttack()