require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("vec2")
require("util")
require("math_ext")
require("movement")

local me, player = nil
local param = {
  origin = { x = 0, y = 0 },
  time = 0
}

local function dist_origin()
  local me = getMe()

  local dx = param.origin.x - me.XPos
  local dy = param.origin.y - me.YPos

  return dx, dy 
end

local function attack_slash(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = false
    data.pressDash = false
    data.meterBurn = false
  end

  doMotion("X+Attack")
end

local function attack_superSlash(data)
  if data ~= nil then
    data.dir = dirs.N
    data.pressAction = true
    data.pressDash = false
    data.meterBurn = false
  end

  doMotion("X+Heruka")
end

-- the initialization function for this AI
function OnInit()
  -- Accessible anywhere in this file after Initialization
  me, player = getMe(), getPlayer()
  local players = getPlayers()

  -- Set origin
  param.time = 0

  if me:getSpawnpointPos() ~= nil then
    param.origin.x, param.origin.y, param.origin.z = me:getSpawnpointPos()
  end
end

-- the main update function for this AI
function OnUpdate()
  while true do
    me, player = getMe(), getPlayer()
    --
    if aiDebug() then
    end

    wait()
  end -- the while loop
end -- the function

function OnBattleAttack(battleData)
  local toReturn = DefaultOnBattleAttack(battleData)
  local me = getMe()

  attack_slash(toReturn)

  return toReturn
end --OnBattleAttack()