-- We need LuaLib for declare
require("LuaLib")

-- We use these for 
require("debug_ext")
require("vec2")
require("math_ext")
require("movement")
require("util")


declare("bh_flying", function(_params)
  local me, player = getMe(), getPlayer()
  --
  local params = _params or nil
  --
  if param.origin then
  else
    param.origin.x = me.XPos
    param.origin.y = me.YPos
  end
  --
  -- How far are we from our goal point
  local vecPos = { x = me.XPos, y = me.YPos }
  if vec_dist( vecPos, param.origin ) >= 160
  then
    local speed = {
      min = 2,
      max = 16,
      range = 160
    }
    if tick_ok() then
      fly_to(param.origin.x, param.origin.y, speed)
    else
      --debugPalette("Debug_Blink")
    end
  end
end)