-- We need LuaLib for declare
require("LuaLib")

declare("lerp", function(low, high, v)
    return low * (1 - v) + high * v
end)

declare("clamp", function(v, min, max)
    return math.max(math.min(v, max), min)
end)
--

-- scale(0.5, 0, 1, 0, 100) gives 50
--[[
declare("scale", function(v, l1, h1, l2, h2)
    if l1 == 0 and h1 == 1 then
        return lerp(v, l2, h2)
    else
        return (v * l1) * (h2 - l2) / (h1 - l1) + l2
    end
end)
]]

declare("scale", function(v, min_in, max_in, min_out, max_out)
  return ((v) - (min_in)) * ((max_out) - (min_out)) / ((max_in) - (min_in)) + (min_out)
end)

declare("inRange", function(v, low, high)
    if ( v >= low) and ( v <= high ) then
        return true
    end
    return false
end)

declare("in_range", function(v, low, high)
    return inRange(v, low, high)
end)