require("LuaLib")
require("MonsterLib")

require("debug_ext")
require("math_ext")
require("util")
require("vec2")
require("movement")

local function attack_whip(data)
    if data ~= nil then
        data.dir = dirs.N
        data.pressAction = false
    end
    doMotion("X+Attack")
end

local function attack_electricity(data)
    if data ~= nil then
        data.dir = dirs.U
        data.pressAction = false
    end
    doMotion("U+Attack")
end

-- the initialization function for this AI
function OnInit()
    local me, player = getMe(), getPlayer()
    
    param.attackWhip = true
    param.attackElectricity = false 

    if has_spawn_command("Electric")
    or has_spawn_command("Zap") then
        param.attackWhip = false
        param.attackElectricity = true
    end

    param.whipRangeX = 160 * 5
    param.whipZapX = 160 * 8 -- does it.. need this?

    -- Set origin
    param.origin = { x = me.XPos, y = me.YPos }
end

-- the main update function for this AI
function OnUpdate()
    local me, player = getMe(), getPlayer()

    -- SCARY HACK WE SHOULD PROBABLY NOT DO --
    while shouldNeverUpdate() do
    
    end

    while true do
        me, player = getMe(), getPlayer()
        --
        if math.abs(dist_player()) <= param.whipRangeX 
        and param.attackWhip 
        and player_vulnerable() then
            attack_whip()
        elseif param.attackElectricity
        and player_vulnerable() then
            attack_electricity()
        end
        
        --
        wait()
    end -- the while loop
end -- the function

function OnBattleAttack(battleData)
    local toReturn = DefaultOnBattleAttack(battleData)
    local me = getMe()
    return toReturn
end --OnBattleAttack()